spi_output	
  	movwf	SSPBUF	      		; place data in buffer
loop1	
 	bsf	    STATUS, RP0  	    ; SSPSTAT is in bank 1
	btfss	SSPSTAT, BF	    	; has data been received?
	goto	loop1		        ; not done yet, keep trying
	bcf	    STATUS, RP0	       	; SSPBUF is in bank 0
	movf	SSPBUF, W	      	; empty receive buffer
	return		            	; return from subroutine
;**************************************************************
ee_ewds	
	bsf	    EE_CS				; set chip select line!
	movlw	b'00100000'			; op code for EWDS
	call	spi_output		    
	movlw	b'00000000'	    	;rq for EWDS
	call	spi_output
	bcf	    EE_CS	      		; bring chip select low!
	return	            		; return from subroutine
;**************************************************************
ee_ewen	
	bcf	    STATUS, RP0	    	; need to set bank 0
	bsf	    EE_CS	      		; set chip select line high
	movlw	b'00100110'	    	; op code for EWEN
	call	spi_output
	movlw	b'00000000'	    	; req for EWEN
	call	spi_output
	bcf	    EE_CS	      		; bring chip select low!
	return
;**************************************************************
ee_write	
	bsf	    EE_CS	      		;set chip select line high
	movf	ee_addr_h, w	    ;put hibyte in w reg
	andlw	0x07				;form remaining bits
	iorlw	0x28
	call	spi_output		    ;
	movf	ee_addr_l, w		;adr low byte
	call	spi_output		    ;
	movf	ee_data, w	     	;get ready to output data
	call	spi_output		    ;
	bcf	    EE_CS	     		;bring chip select low to begin
			                    ;EEPROMs internal write cycle
	nop		              	    ;cs must be low for > 250 ns
	bsf	    EE_CS        		;and then brought high
rbusy	
  	btfss	SDI	    			;test ready/busy status
			                    ;if 1, internal write is done
	goto	rbusy		        
	bcf	    EE_CS	      		; bring cs back low
	return
;**************************************************************
ee_read
	bsf	    EE_CS	      		;set chip select line high
	bsf	    SSPCON, CKP	    	;make sure CKP is 1 to output
			                    ;next intstruction and addr
	movf	ee_addr_h, w	    ;move data from hibyte to w
	andlw	0x07				;form remaining bits
	iorlw	0x30
	call	spi_output		    ;
	movf	ee_addr_l, w	    ; get ready to send next byte
			                    ; which is the 8 lsb address bits
	call	spi_output		    ;
;	This is where CKP bit is reset for receiving data.
	bcf	    SSPCON, CKP	    	; change clock polarity to 0
	movlw	0x00		        ; The byte here is a don't care
	call	spi_output		    ;
	bcf	    EE_CS	      		; bring chip select low
	movwf	ee_data		      	; move received data to reg
	bsf	    SSPCON, CKP
	return	            		;
;**************************************************************
