	movwf 	W_TEMP 			;Copy W to TEMP register
	swapf 	STATUS,W 		;Swap status to be saved into W
	movwf 	STATUS_TEMP 	;Save status to bank zero STATUS_TEMP register
	btfsc	INTCON,TMR0IF
	goto	tmr1_int


int_end
	swapf 	STATUS_TEMP,W 	;Swap STATUS_TEMP register into W
	movwf 	STATUS 			;Move W into STATUS register
	swapf 	W_TEMP,F 		;Swap W_TEMP
	swapf 	W_TEMP,W 		;Swap W_TEMP into W
	retfie

tmr1_int
	bcf		INTCON,TMR0IF	;reset interrupt flgg
	clrf	STATUS			;reste status bits
	incf	int_count_s,f	;increase counter
	movlw	.20				;because of interrupt every 50ms
	xorwf	int_count_s,W	;after 20 cycles
	btfss	STATUS,Z
	goto	ti_non1s
	clrf	int_count_s		;clear counter
	incf	int_count_secs	;1 second counter
ti_non1s

	movlw	.2				;prepare 2
	clrf	keys_new		;init reg
	btfss	K1				;if K1 pressed
	incf	keys_new		;increase from 0 to 1 (set bit 0)
	btfss	K2				;if K2 pressed
	addwf	keys_new,f		;add also 2 (set bit 1)
	movf	keys_old,W		;take previous state
	xorwf	keys_new,W		;any change?
	andwf	keys_new,W		;and change from 0->1?
	iorwf	keys,f			;set (but don't clear) those bits
	movf	keys_new,W		;take new values
	movwf	keys_old		;and set as old for next cycle
	movlw	0x3D			;reload timer
	movwf	TMR0
	goto	int_end



