init
	clrf	STATUS
	clrf	TRISA
	clrf	PORTC		        ; initialize port c
	movlw 	0x80
	movwf	RCSTA
	bsf	    STATUS, RP0
	movlw	0x07
	movwf	OPTION_REG
	movlw	0x24
	movwf	TXSTA
	movlw	.25
	movwf	SPBRG
	movlw	0x90
	movwf	ADCON1
	movlw	0x60
	movwf	OSCCON
	movlw	0x10		        ; all bits are outputs except SDI
	movwf	TRISC		        ; for SPI input
	movlw	0x3F
	movwf	TRISA
	clrf	PIE1		        ; disables all peripheral ints
	clrf	INTCON		      	; disables all interrupts
	bsf		STATUS, RP1
	bcf	    STATUS, RP0
	movlw	0x80
	movwf	CM2CON0
	bsf		STATUS, RP1
	bsf	    STATUS, RP0
	movlw	0x07
	movwf	ANSEL
	movlw	0x00
	movwf	ANSELH
	clrf	STATUS
	movlw	0xC1
	movwf	ADCON0
	clrf	SSPCON		      	; clear SSP control register
	movlw	0x31		        ; SPI master, clk/16, ckp=1
	movwf	SSPCON		      	; SSPEN enabled
	clrf	int_count_s
	clrf	int_count_secs
	clrf	keys
	clrf	keys_old
	clrf	cur_addr_h
	clrf	cur_addr_l
	clrf	ee_addr_h
	clrf	ee_addr_l
	clrf	state

	return



do_adc								;do AD conversion, obviously
	bsf		ADCON0,GO_DONE
do_adc_loop
	btfsc	ADCON0,GO_DONE
	goto	do_adc_loop
	movf	ADRESH,W
	movwf	adres_h
	bsf		STATUS,RP0
	movf	ADRESL,W
	bcf		STATUS,RP0
	movwf	adres_l
	return